- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ fusion_name }}"
    policy_name: "{{ fusion_name }}-to-{{ ldap_name }}"
    policy_state: "{{ 'present' if (do_fusion
                                    and do_network_policy)
                                else 'absent' }}"
    subject: "{{ ldap_name }}"
    to:
    - number: "1389"
    - number: "1636"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - name: "{{ fusion_name }}"
    policy_name: "{{ fusion_name }}-to-{{ lemon_name }}"
    policy_state: "{{ 'present' if (do_fusion
                                    and do_lemon
                                    and do_network_policy)
                                else 'absent' }}"
    subject: "{{ lemon_name }}"
    to:
    - number: "8080"
- include_role:
    name: commons
    tasks_from: helpers/deployment.yaml
  vars:
    cpu_limit: "{{ fusion_cpu_limit }}"
    cpu_request: "{{ fusion_cpu_request }}"
    dc_data: "{{ lookup('template', 'fusion.j2') }}"
    dc_name: "{{ fusion_name }}"
    dc_replicas: "{{ fusion_replicas }}"
    dc_state: "{{ 'present' if (do_fusion)
                            else 'absent' }}"
    dc_tag: "{{ fusion_tag }}"
    exporter_idx: 1
    exporter_tag: "{{ httpexporter_tag }}"
    memory_limit: "{{ fusion_memory_limit }}"
    memory_request: "{{ fusion_memory_request }}"
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    ports:
    - 8080
    svc_name: "{{ fusion_name }}"
    svc_state: "{{ 'present' if (do_fusion)
                             else 'absent' }}"
- include_role:
    name: commons
    tasks_from: helpers/route.yaml
  vars:
    route_host: "{{ fd_domain }}"
    route_name: "{{ fusion_name }}"
    route_state: "{{ 'present' if (do_fusion)
                               else 'absent' }}"
    svc_name: "{{ fusion_name }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ default_namespace_match }}"
    policy_name: "public-to-{{ fusion_name }}"
    policy_state: "{{ 'present' if (do_network_policy
                                    and do_fusion)
                                else 'absent' }}"
    subject: "{{ fusion_name }}"
    to:
    - number: "8080"
- include_role:
    name: commons
    tasks_from: helpers/service.yaml
  vars:
    is_exporter: True
    ports:
    - 9113
    svc_name: "{{ fusion_name }}"
    svc_state: "{{ 'present' if (do_exporters
                                 and do_fusion)
                             else 'absent' }}"
- include_role:
    name: commons
    tasks_from: helpers/network-policy.yaml
  vars:
    source:
    - namespace: "{{ prometheus_namespace_match }}"
    policy_name: "prometheus-to-{{ fusion_name }}"
    policy_state: "{{ 'present' if (do_exporters
                                    and do_fusion
                                    and do_network_policy)
                                else 'absent' }}"
    subject: "{{ fusion_name }}"
    to:
    - number: "9113"
- include_role:
    name: commons
    tasks_from: helpers/autoscale.yaml
  vars:
    autoscale_cpu_target: "{{ fusion_hpa_cpu_target | default(hpa_cpu_target | default(75)) }}"
    autoscale_name: "{{ fusion_name }}"
    autoscale_state: "{{ 'present' if (fusion_replicas not in [ 0, '0' ]
                                       and do_fusion)
                                   else 'absent' }}"
    max_replicas: "{{ fusion_max_replicas | default(hpa_max_replicas | default(4)) }}"
    min_replicas: "{{ fusion_min_replicas | default(fusion_replicas) }}"
- include_role:
    name: commons
    tasks_from: helpers/wait-for.yaml
  vars:
    check_with: "{{ lookup('k8s', api_version=deployment_apivers,
                           kind=deployment_kind, namespace=namespace,
                           resource_name=fusion_name) | default('') }}"
    obj_name: "{{ fusion_name }}"
    retries_for: 30
    wait_for: 10
  when:
  - do_fusion
  - dc_started is defined
  - dc_started.changed | default(False)
- include_role:
    name: commons
    tasks_from: helpers/poddisruptionbudget.yaml
  vars:
    pdb_name: "{{ fusion_name }}"
    pdb_min_available: 1
    pdb_state: "{{ 'present' if ((fusion_replicas | int) > 1
                                 and do_fusion
                                 and do_pdb)
                             else 'absent' }}"
